
package DiversityPackage;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.DocumentBuilder;
import org.apache.jena.ext.com.google.common.collect.ArrayListMultimap;
import org.apache.jena.ext.com.google.common.collect.Multimap;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;
import org.w3c.dom.Node;
import org.w3c.dom.Element;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Hashtable;
import java.util.Set;

public class RetrieveEntitiesFromGATEInlineXML {
	
		public static Hashtable <String, ArrayList> RetrieveFromGATEXML() throws SAXException, IOException, ParserConfigurationException {
			// input annotated file	  
			File fXmlFile = new File("StudyA-EntitiesPerVideo-DomainDiversityZoomin-OnlineCopy-v1.xml");//study A- Per Video- For domain diversity zoom-in per video
		DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
		Document doc = dBuilder.parse(fXmlFile);
		doc.getDocumentElement().normalize();
		NodeList nList = doc.getElementsByTagName("UsersCommentsPerVideo");//AVW dataset 38 users comments diversity zoom in and overview
		
		Multimap <String, ArrayList> VIDmultimap = ArrayListMultimap.create();
		
		for (int temp = 0; temp < nList.getLength(); temp++) 
		{
		    Node nNode = nList.item(temp);
		    if (nNode.getNodeType() == Node.ELEMENT_NODE) 
			{
				Element eElement = (Element) nNode;
			//	String VId=eElement.getAttribute("User__Id");
				String VId=eElement.getAttribute("DigitalObject__Id");	
				//NodeList L=eElement.getElementsByTagName("Lookup");// for location its not a list, it is a one uri for each node, for comments will be list of uris
				NodeList L=eElement.getElementsByTagName("URI");//AVW dataset- 38 users comments diversity zoom in and overview
				String URI = null;
				ArrayList Uri=new ArrayList();
				for (int j=0;j<L.getLength();j++)
				{
					Node NL=L.item(j);
					if (NL.getNodeType() == Node.ELEMENT_NODE) 
					{
						Element e = (Element) NL;
						//URI=e.getAttribute("URI");	
						//Uri.add(URI);
						Uri.add(e.getTextContent());
			        }
		        }
				if (!(Uri.isEmpty()))
				{
				 //put each video with its entities several times- non unique keys
			      VIDmultimap.put(VId, Uri);
	
				}			
		}
		}
		
		Hashtable <String, ArrayList>EntitiesPerVideo=new Hashtable();
		Set<String> keys = VIDmultimap.keySet();
	    for (String VID : keys) 
	     {
		   //Flatten the list of lists in the multimap
			ArrayList E=new ArrayList();
		    Collection<ArrayList> EList = VIDmultimap.get(VID);
		    EList.forEach(E::addAll);
		       //E.addAll(EList);
		    EntitiesPerVideo.put(VID, E);
		        
	     }
	
		return EntitiesPerVideo;
	}
		public static Hashtable <String, ArrayList> RetrieveFromGATEXMLEntryPoint(ArrayList EPChildren) throws SAXException, IOException, ParserConfigurationException {
			
				File fXmlFile = new File("StudyA-EntitiesPerVideo-DomainDiversityZoomin.xml");//study A- Per Video- For domain diversity zoom-in per video   
				DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
				DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
				Document doc = dBuilder.parse(fXmlFile);
				doc.getDocumentElement().normalize();

				NodeList nList = doc.getElementsByTagName("UsersCommentsPerVideo");
		        Multimap <String, ArrayList> VIDmultimap = ArrayListMultimap.create();
				
				for (int temp = 0; temp < nList.getLength(); temp++) 
				{
				    Node nNode = nList.item(temp);
				    if (nNode.getNodeType() == Node.ELEMENT_NODE) 
					{
						Element eElement = (Element) nNode;
						//String VId=eElement.getAttribute("User__Id");
						String VId=eElement.getAttribute("DigitalObject__Id"); 
						//NodeList L=eElement.getElementsByTagName("Lookup");// for location its not a list, it is a one URI for each node, for comments will be list of URIs
						NodeList L=eElement.getElementsByTagName("URI");
						String URI = null;
						ArrayList Uri=new ArrayList();
						for (int j=0;j<L.getLength();j++)
						{
							Node NL=L.item(j);
							if (NL.getNodeType() == Node.ELEMENT_NODE) 
							{
								Element e = (Element) NL;
								//URI=e.getAttribute("URI");
								URI=e.getTextContent();
								if(EPChildren.contains(URI))
						    	   {
									Uri.add(URI);
						    	   }
					         }
				        }
						if (!(Uri.isEmpty()))
						{
						 //put each video with its entities - non unique keys
					      VIDmultimap.put(VId, Uri);
						}
					
				}
				}
				Hashtable <String, ArrayList>EntitiesPerVideo=new Hashtable();
				Set<String> keys = VIDmultimap.keySet();
			    for (String VID : keys) 
			     {
				   //Flatten the list of lists in the multimap
					ArrayList E=new ArrayList();
				    Collection<ArrayList> EList = VIDmultimap.get(VID);
				    EList.forEach(E::addAll);
				       //E.addAll(EList);
				    EntitiesPerVideo.put(VID, E);
				        
			     }
			    return EntitiesPerVideo;
				
			}
}